// Klasse erbt von Thread
public class JoinAndSleep  extends Thread{
	
	//Instanzvariablen
    Thread joinIt;
    int schlafen;

    //Konstruktor
    public JoinAndSleep(int sleeptime, Thread toJoin) {
        joinIt = toJoin;
        schlafen = sleeptime;
        //Thread wurde erzeugt. Befindet sich also im Zustand NEW
        System.out.println("Thread: " + this.getName() + " Zustand: "+this.getState());
    }

    // Run Methode berschreiben. Dieser Code wird parallel ausgefhrt, wenn der Thread mit .start() gestartet wird.
    @Override
    public void run() {
    	
    	// Thread wurde gestartet. Befindet sich also im Zustand Runnable
        System.out.println("Thread: " +Thread.currentThread().getName() + " Zustand: "+this.getState());
        try {
        	
        	// Falls er auf einen Thread warten soll, wird join() auf den zu wartenden Thread aufgerufen.
            if (joinIt!=null) {
                joinIt.join();
                System.out.println("Thread: " +Thread.currentThread().getName()
                        + " join auf " + joinIt.getName() + " fertig");
            }
        } catch (InterruptedException e) {}
        
        // Danach geht er fuer die angegebene Zeit schlafen. 
        System.out.println("Thread: " +Thread.currentThread().getName() 
                + " schlaeft jetzt fuer " + schlafen + "ms");
        try {
            Thread.sleep(schlafen);
        } catch (InterruptedException e) {}
        
        // Thread endet und verlaesst die Run-Methode. Damit geht er in den Zustand TERMINATED ueber. 
        System.out.println("Thread: " +Thread.currentThread().getName() + " endet");
    }   
    
  
    /**
     * Main-Methode
     * @param args
     */
    public static void main (String[] args) {
    	
    	// Threads erzeugen.
        JoinAndSleep s3= new JoinAndSleep(4000, null);
        JoinAndSleep s2= new JoinAndSleep(3000, s3);
        JoinAndSleep s1= new JoinAndSleep(2000, s2);
        
        // Threads starten.
        s1.start();
        s2.start();
        s3.start();
    }
}
